## 软素质篇
### 1、面试误区
#### 1. 不给做事的思路，直接给结论（展现思维能力，有解决问题的能力）
- 直接给结论，让面试官了解你的成果，这一点是没有问题的。但你也需要告诉面试官，你是怎么做出来的。我们拿接口测试举例，你可以这么和面试官说：我使用 pytest + requests + Allure2 做个接口自动化测试。这是结论。当时做接口自动化的时候，我仔细对比了 uiittest 和 pytest 这两个框架，发现 pytest 这个框架的 XXX 优点，更适合我们的的业务。
#### 2. 给了思路，没有体现自己对于事情的洞察和理解（考察对本质的思考）
- 只是单纯的描述工作流程，没有体现自己对事情的洞察和理解。接口为什么用 pytest + requests 框架？unittest 和pytest 有哪些区别？两个框架的优点和劣势是什么？你是怎么理解的？在使用的过程中，遇到了哪些坑又是怎么趟过去的？你的思考是什么？有哪些经验可以在公司应用提高公司的效率？你说明白了这些，那么，面试官一定会对你刮目相看的
#### 3. 考验你是不是有一颗好奇心，是否有自己的理解
- 测试行业的技术日新月异，有哪些是比较通用的？有哪些是比较小众但优质的技术？比方，做 app 自动化测试，我们都用 appium，但是 airtest 也是一款非常优秀的自动化测试工具。那么，做 app 测试时，什么时候用 appium 比较好什么时候用 airtest 会更高效呢？如果能够说出自己的理解，那么，你在面试官的心里，那一定是非你莫属的地位呀
### 2、从实习中学到了哪些有用的东西
4个方面总结回答
1. **工作方法**
2. **工作技能**
3. **解决问题的能力**
4. **工作方式相关**
详细拆解
1. **工作方法拆解**：在实习期间，有哪些比较好的工作方法呢？公司的管理流程是什么样的？或者，你对这些都不太了解，是不是可以总结一下，从开始介入测试到测试报告提交这一整套的流程是什么？为什么是这一套流程呢？这套流程有哪些优点呢？ 
2. **工作技能拆解**：在实习工作中，都学习到哪些技能了呢？比方，web自动化测试用的是什么工具？为什么选择这个工具？这个收益是什么？可能遇到的难点是什么？容易踩「坑」的点在哪里呢？你学到了哪些？ 如果能够把这些用工作流程串起来。那么，这是一个非常亮眼的回答。
3. **解决问题的能力拆解**：工作中经常遇到的问题有哪些？例如：做测试经常会遇到项目延期的问题，那么领导都是如何沟通的？如果遇到提测的代码质量不合格，那么领导都是怎么做的？你从中学到了什么？如果遇到这样的问题，你要如何去与开发、产品沟通呢？
4. **工作方式相关拆解**：在工作方式中，你的领导有哪些比较好的工作方式，整个团队的工作方式是什么样的？你从中学到了哪些对你有益的点？这些点对你有哪些影响呢？这其中的每一点都可以展开来细说的。
### 3、面试前需要做哪些准备
- 自我介绍
	- 重点：基本信息+匹配+亮点+对面试公司的认可
	- 你好面试官，我叫xx，毕业于xxx大学，有xxx年工作经验。个人认为我对此岗位的匹配度很高，原因如下
	- 第一：专业匹配，此外，还曾获得xxx奖项
	- 第二：业务经验匹配度高，贵公司主要为金融业务，而我具有5年金融相关的业务测试经验
	- 第三：技术要求符合需求，我在JD中看到贵公司的主要需求为CICD，而我在之前xx项目中具有从0到1搭建CICD体系的相关经验

注意：自我介绍不要过分冗长！控制在3分钟内即可
- 项目介绍
- 常见问题
1. 自我评价/他人评价/优点缺点。
2. 印象深刻的bug。
3. 职业规划
	- 重点：强调短期规划与长期目标
		- 在3个月~半年内要胜任基本工作。
		- 在在1~3年内，要达到更高级别的水准，帮助公司构建完整的质量体系。  
		
	注意：职业规划要明确。可以适当灵活调整
4. 最近看了什么书
**项目介绍：使用Xmind 提前总结自己做过的项目内容**
![](assets/面试总结复盘.png)

| 类型        | 含义  |
| --------- | --- |
| situation | 情境  |
| task      | 任务  |
| action    | 行动  |
| result    | 结果  |
1. 项目背景（situation）
2. 项目目标（task）
3. 项目贡献（action）
4. 项目结果（result）
示例：
问题：讲一下你最近做过的项目
- Situation: 我所在的项目组是做终端业务的（situation），我在其中的职责是测试经理，我与我的团队主要负责整个终端业务的质量保证。
- Task:
    - 提升整个测试团队的效率（task），因为我们之前每次发版的时候，测试的时候被挤压的比较厉害。测试时间不太够，老板又不太想加人力了，所以就想通过提升测试效率解决测试时间不足的问题。
- Action:
    - 为了提升测试效率，制定了一套完整的测试计划，里面包含每个时间段我们要完成的工作内容。其中部分工作，需要研发和运维协调。
    - 其中有一项任务是通过 mock socket 协议的请求，完成软件与硬件的解耦，解放测试人员，让测试人员不用去到实施现场，才能测试，从而提升测试效率
    - …其他 action…（尽量挑亮点讲）
- Result：最后项目完成后，通过以上的这些方式，比如自动化测试，软硬件解耦，整提测试效率提升了 n 倍，节省了时间成本和人力。
### 4、线上有故障，测试应该怎么做，如何去推动。

### 5、当发现一个开发否认的bug，你会怎么去做

### 6、作为一个小组leader，你是如何对上汇报，对下安排任务的

### 7、你对团队成员如何评价的，如果让你给他们打绩效，你会怎么去制订

### 8、当你和领导或者下属存在不同意见的时候，你会怎么去做才能完成你自己的想法。
答：



## 反问面试管篇
### 1、你有什么想问我的？
#### 1. 可以问的问题
技术面的面试官问你的时候，那你可以问一问**具体的岗位职责及目前​岗位工作的重点。还有团队的人员编制，也就是说测试开发比是多少？**
而如果是 HR 问你这个问题，那你可以问一问**大概什么时候能够收到面试结果的通知**。但这里一定要注意，**一定不能问面试结果是什么**。这里可以​问一问**薪资体系**。比如，薪资​构成的体系是什么样的？一年大概​十几薪呀？ 其他的，记得就不要问了。
**1、职责**
- 团队中初级和高级人眼如何平衡
- 针对员工有哪些培训和提升计划
**2、技术**
- 公司内部的技术栈
- 产品的架构
- 版本控制及迭代速度
- 服务器管理权限，本机家算计管理权限
**3、团队**
- 团队内和团队之间如何沟通
- 遇到了分歧如何解决
- 团队正在经历的尚未解决的挑战是什么
- 绩效考核是如何算的
**4、公司**
- 晋升机会
- 是否有自己的学习资源
- 假期，加班工资等
- 过去半年最糟糕的一天是怎么样的
- 是什么让你来到并留在这里
- 是否能够平衡工作与生活
#### 2. 千万不要问的问题
那有哪些问题是千万不要问的呢？有哪些一问​就特别败好感的问题呢？
**第一点：公司的一些薪酬福利不要问** 。比方说，是否有饭补、餐补、​加班补助等。这些都是公司的明文规定，你要是入职了自然会知道。而且如果把这个问题问在了补助上面，那会让 HR 觉得你只顾着「福利」，大概率也不是想认真干活的​，这个是很败好感的。
**​第二点：能够查到的千万不要问。** 比如，这家公司​是做什么业务的？他的竞争对手​是哪些？你如果坦率地问出来，那么面试官会认为你对该面试不重视。
**​第三点：对方回答不了的不要问。** 比如​，面试结果是什么？公司未来的发展战略是什么？这些要么是不能回答要么是没办法回答的问题，咱们就不要难为面试官啦​。毕竟，能不能拿到offer，各个面试官的建议都很重要的哦​。
### 2、自己的优点和缺点
- 避开岗位的核心技能
- 把缺点放在场景中描述
- 对缺点进行合理化解释
- 优点随便说，主要方向还是在岗位上
### 3、是否能接受加班，建议分情况作答
- 第一种情况：假设公司有重要的项目要赶。示范回答：贵公司现在正处于发展上升期，也在官网上有看到公司的重要项目成果，我觉得有时候因为赶项目进度、工作需要等忙起来是非常正常的，面对这种情况，我是非常愿意配合公司和团队的工作，让工作能够更顺利地完成，此外，我也相信自己一定能在公司安排的工作中获得到锻炼，获得更快地成长。
- 第二种情况：假设自己作为新人，对业务不熟悉。示范回答：我作为公司刚进去的新人，可能刚开始进入公司接触业务时不太熟练，会出现需要加班的情况，但我更愿意提高工作效率，并积极向公司的前辈请教学习，在一定的时间内完成工作而不是拖到下班之后。当然， 如果有紧急的事情，忙起来需要加班也是可以接受的。
### 4、未来5年的职业规划
- 自我认知。对自己是否了解，了解是不是靠谱。
- 动机和价值观。你是否能接受我们并不一定能给你公平的职业发展机会这个现实？
- 组织承诺。你到底能在我们这踏实的干几年？
重点：强调短期规划与长期目标  
在3个月~半年内要胜任基本工作。  
在在1~3年内，要达到更高级别的水准，帮助公司构建完整的质量体系。  
注意：职业规划要明确。可以适当灵活调整
### 5、薪酬的要求
- 薪资并不是我求职的唯一标准，我上家公司基本在A~B 之间（建议合理提高，避免部分HR压价）
- 我来贵司求职的主要动机是兴趣，这份工作是我喜欢做的，也相信自己可以胜任，更相信公司会给出一个合理的薪酬。
- 相比薪酬，我更在意的是收入，所以，我很愿意了解贵司的薪酬架构，可以简单介绍下吗？
- 我希望薪资可以达到**，据我了解，贵司这个岗位薪资范围是A~B ，而结合岗位职责及任职要求，我对自己也进行了相应评估，也愿意接受贵司的下一步考核。
### 6、我们为什么要聘用你
- 描述应聘岗位的胜任条件，强调自己的工作能力和工作经验跟岗位的匹配度，岗位要求的工作技能是否自己掌握了，掌握的程度是怎样的，最好在面试中说出来。因此，在面试前最好是要针对应聘岗位，把自己胜任的条件一一列出来，做到知己知彼。可以谈论一下自己之前的工作情况，用成绩、用数据来说明自己的成就。
- 描述自己能为公司做出什么贡献，公司是一个讲究利益的地方，聘用你肯定要你为公司做出贡献。那么你在回答这个问题时，就需要说出你的加入可以为公司带来什么，这非常重要。因此，一定要明确你的工作目标和职业规划，表明你的立场和专业程度，让HR信任你。
- 描述出自身的优势。公司为何要聘用你，而不聘用别人，肯定是你有比别人优秀的地方。那么在回答这个问题时，就一定要说出自己与众不同的地方，最好是要举一个例子，来支持你的观点。
- 建立个人和公司的联系，HR想要得到一个怎样的答案呢？无非就是想通过这个问题，来进一步了解你各方面的信息，以及看看你为这次面试做了多少功课。那么在面试前，你最好是要尽可能获取有关公司可行业的资料信息。在回答的时候，结合自己所做的功课，建立个人和公司的联系，说明自己在哪一方面能够匹配公司的要求。HR看到你对应聘岗位这么了解，肯定会对你有好感。
- 说出你对这份工作的兴趣以及热情
### 7、缺乏工作经验，如何胜任这份工作
- 承认工作经验的重要性。这样能带给面试官的印象是：该位候选人认知能力较强，具有理性思维与客观公正的处事态度及判断能力，尤其是对于自己也能客观公正地看待，勇于承认自己的缺失。
- 突显个人优势。用自己的其他优势特长来补足经验上的不足，比如说记忆力好、动手能力强、语言能力强、学习能力强等。
- 强调自己会不断提高工作能力。切忌用假大空的话，要用具体的与工作相关的事例或是数据来说明自己的学习力。